package eu.univento.commons;

import eu.univento.commons.configuration.ConfigurationHandler;
import eu.univento.commons.database.DatabaseManager;
import eu.univento.commons.logging.LoggingHandler;
import eu.univento.commons.security.SecurityHandler;
import eu.univento.commons.web.slack.SlackHandler;
import lombok.Getter;

/**
 * @author joethei
 * @version 0.1
 */

@Getter
public class Commons {

    private DatabaseManager databaseManager;
    private ConfigurationHandler configurationHandler;
    private SecurityHandler securityHandler;
    private LoggingHandler loggingHandler;
    private SlackHandler slackHandler;

    public Commons() {
        configurationHandler = new ConfigurationHandler();
        databaseManager = new DatabaseManager(this);
        securityHandler = new SecurityHandler(this);
        loggingHandler = new LoggingHandler();
        slackHandler = new SlackHandler(configurationHandler.getString("Slack.hook_url"));
    }

    public void shutdown() {
        getDatabaseManager().closeConnections();
    }

}