package eu.univento.commons.player.language;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;

/**
 * @author joethei
 * @version 0.1
 */
public class Language {

    private final ResourceBundle translation;

    public Language(String language) {
        Map<String, Locale> languages = new HashMap<>();
        languages.put("DE", Locale.GERMAN);
        languages.put("EN", Locale.ENGLISH);
        languages.put("IT", Locale.ITALIAN);
        translation = ResourceBundle.getBundle("language", languages.get(language));
    }

    public String getWord(String keyword) {
        return translation.getString(keyword);
    }

    public String getMessage(MessageConstant constant) {
        return translation.getString(constant.getName());
    }
}