package eu.univento.commons.player.statistics;

import eu.univento.commons.player.DatabasePlayer;
import eu.univento.commons.server.ServerType;

import java.util.HashMap;
import java.util.Map;

/**
 * @author joethei
 * @version 0.1
 */

public class GameStats {


    public ServerType type;
    private DatabasePlayer player;
    private Map<String, Object> stats = new HashMap<>();

    public GameStats(ServerType type, DatabasePlayer player) {
        this.type = type;
        this.player = player;
        stats = player.getMapFromDatabase(type.getName());

    }

    public Long getStat(String name) {
        return (Long) stats.get(name);
    }

    private void setStats(Map<String, Object> stats) {
        player.setInDatabase(type.getName() + "Stats", stats);
    }

    public void setStat(String name, Long value) {
        Map<String, Object> map = stats;
        map.put(name, value);
        setStats(map);
    }
}