package eu.univento.commons.security;

import eu.univento.commons.Commons;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.function.Consumer;

/**
 * @author joethei
 * @version 0.1
 */
public class SecurityHandler {

    private Commons commons;

    private ArrayList<String> cache = new ArrayList<>();

    public SecurityHandler(Commons commons) {
        this.commons = commons;
        load(resultSet -> {
            try {
                while (resultSet.next()) {
                    cache.add(resultSet.getString("ip"));
                }
                resultSet.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        });
    }

    public boolean isValidServer(String ip) {
        return cache.contains(ip);
    }

    private void load(Consumer<ResultSet> consumer) {
        commons.getDatabaseManager().getAsyncMySQL().query("SELECT * FROM Servers;", consumer);
    }
}